com.smartgwt.client.widgets

## Class UserSummary

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.widgets.UserSummary

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers

      public class UserSummary
      extends DataClass

  An object representing a user-created and user-modifiable summary, which can be created and edited with a SummaryBuilder either directly or via the `ListGrid.canAddSummaryFields` behavior.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UserSummary()`
    `UserSummary(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `UserSummary(java.lang.String text)`
    `UserSummary(java.lang.String text, java.util.Map summaryVars)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static UserSummary` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.util.Map` | `getSummaryVars()` Map from the all-capital letter names used as summary variables in the `UserSummary` String to the fieldNames these variables should represent in the context where the summary is evaluated.
    `java.lang.String` | `getText()` Summary to be evaluated.
    `void` | `setSummaryVars(java.util.Map summaryVars)` Map from the all-capital letter names used as summary variables in the `UserSummary` String to the fieldNames these variables should represent in the context where the summary is evaluated.
    `void` | `setText(java.lang.String text)` Summary to be evaluated.

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### UserSummary

          public UserSummary()

    - #### UserSummary

          public UserSummary(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### UserSummary

          public UserSummary(java.lang.String text)

    - #### UserSummary

          public UserSummary(java.lang.String text,
                             java.util.Map summaryVars)

  - ### Method Detail

    - #### getOrCreateRef

          public static UserSummary getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setSummaryVars

          public void setSummaryVars(java.util.Map summaryVars)

      Map from the all-capital letter names used as summary variables in the `UserSummary` String to the fieldNames these variables should represent in the context where the summary is evaluated.

      When used in `ListGridField.userSummary` context, field names are evaluated against the grid record.

      When used in `FormItem.textFormula` or `ListGridField.editorTextFormula` this property is not used for summary mapping. Instead, field names are evaluated directly against the current `rule context`.

      Parameters:
        `summaryVars` - New summaryVars value. Default value is null

    - #### getSummaryVars

          public java.util.Map getSummaryVars()

      Map from the all-capital letter names used as summary variables in the `UserSummary` String to the fieldNames these variables should represent in the context where the summary is evaluated.

      When used in `ListGridField.userSummary` context, field names are evaluated against the grid record.

      When used in `FormItem.textFormula` or `ListGridField.editorTextFormula` this property is not used for summary mapping. Instead, field names are evaluated directly against the current `rule context`.

      Returns:
        Current summaryVars value. Default value is null

    - #### setText

          public void setText(java.lang.String text)

      Summary to be evaluated.

      There are two contexts where a UserSummary is used: `ListGridField.userSummary` and `FormItem.textFormula` or `ListGridField.editorTextFormula`. For the grid field summary all variables used by the summary must be all-capital letter names surrounded by braces and escaped with a # sign (eg #{A}). These are derived from field values for the record in question - see `summaryVars`.

      In the second usage context variables are dot-separated (.) names representing the nested hierarchy path to the desired value within the `rule context`. No mapping with `summaryVars` is needed.

      Parameters:
        `text` - New text value. Default value is null

    - #### getText

          public java.lang.String getText()

      Summary to be evaluated.

      There are two contexts where a UserSummary is used: `ListGridField.userSummary` and `FormItem.textFormula` or `ListGridField.editorTextFormula`. For the grid field summary all variables used by the summary must be all-capital letter names surrounded by braces and escaped with a # sign (eg #{A}). These are derived from field values for the record in question - see `summaryVars`.

      In the second usage context variables are dot-separated (.) names representing the nested hierarchy path to the desired value within the `rule context`. No mapping with `summaryVars` is needed.

      Returns:
        Current text value. Default value is null